
#ifndef _Context_h
#define _Context_h

#include <stdio.h>

#include "Globals.h"
#include "Document.h"

class Context {
public:
  Context();

  bool m_bB, m_bEM, m_bI, m_bS, m_bTT;
  int m_nU, m_nSize;
  ItemType m_eColor;

  bool operator==(Context const &rhs) const;

  bool WhitespaceCompressible() const;


  static Context TransformContext (Context const *pSource, DocItemHandle pItem);
  static Context WhitespaceContext (Context const &c);

  typedef bool(CompareFunc)(Context const &c1, Context const &c2);
  static bool TextContextEquivalent (Context const &c1, Context const &c2);
  static bool WhitespaceContextEquivalent (Context const &c1, Context const &c2);

  static bool CompareTextOutput (ConstListNode begin1, ConstListNode end1, ConstListNode begin2, ConstListNode end2);
  static bool CompareWhitespaceOutput (ConstListNode begin1, ConstListNode end1, ConstListNode begin2, ConstListNode end2);

  void print(FILE *file) const;
};

#endif //_Context_h
