
#ifndef _Document_h
#define _Document_h

#include <list>
#include <string>

#include "handle.h"
#include "Globals.h"

using namespace std;

class Document : public list<DocItemHandle> {
public:

  int docSize();
  int write(char *pDest);

  void RemoveTagPair(iterator item);

  static bool CompareOutput(Document const &doc1, Document const &doc2,
    const_iterator &begin1, const_iterator &end1, const_iterator &begin2, const_iterator &end2);
  static void CollectString(const_iterator iBegin, const_iterator iEnd, bool bIgnoreTags, string &outString);
  static void FindNextSequence(const_iterator item1, const_iterator itemEnd, const_iterator &outBegin, const_iterator &outEnd);
  static bool CompareSequence(const_iterator begin1, const_iterator end1, const_iterator begin2, const_iterator end2);
};

typedef Document::iterator ListNode;
typedef Document::const_iterator ConstListNode;
typedef list<ListNode> ListNodeList;

#endif //_Document_h
