
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>

#include "Document.h"
#include "BuildDoc.h"

int main (int argc, char **argv) {
  int nBufSize = (1024 * 1024 * 5) + 1;
  char *pcTemp = new char[nBufSize];

  if (argc < 3) {
    fprintf(stderr, "usage: %s <file1> <file2>\n");
    return 0;
  }
  char *pcFile1 = argv[1];
  char *pcFile2 = argv[2];
 
  int fd, c;

  if ((fd = open(pcFile1, O_RDONLY)) < 0) {
    fprintf(stderr, "error opening %s: %s\n", pcFile1, strerror(errno));
    return 1;
  }
  if ((c = read(fd, pcTemp, nBufSize)) < 0) {
    fprintf(stderr, "error reading %s: %s\n", pcFile1, strerror(errno));
    return 1;
  }
  Document *pDocument1 = new Document();
  BuildDoc(pDocument1, pcTemp, c);

  if ((fd = open(pcFile2, O_RDONLY)) < 0) {
    fprintf(stderr, "error opening %s: %s\n", pcFile2, strerror(errno));
    return 1;
  }
  if ((c = read(fd, pcTemp, nBufSize)) < 0) {
    fprintf(stderr, "error reading %s: %s\n", pcFile1, strerror(errno));
    return 1;
  }
  Document *pDocument2 = new Document();
  BuildDoc(pDocument2, pcTemp, c);

  Document::const_iterator begin1, end1, begin2, end2;
  bool bResult;
  string sReason;
  bResult = Document::CompareOutput(*pDocument1, *pDocument2, begin1, end1, begin2, end2);
  printf ("%d\n", bResult);
  if (!bResult) {
    string s1, s2;
    Document::CollectString(begin1, end1, true, s1);
    Document::CollectString(begin2, end2, true, s2);
    printf ("mismatch:\n%s-----------------------------------------\n%s\n", s1.c_str(), s2.c_str());
  }
  return 0;
}
  
