
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>

#include "Document.h"
#include "BuildDoc.h"
#include "Optimize.h"

int main (int argc, char **argv) {
  int nBufSize = (1024 * 1024 * 5) + 1;
  char *pcTemp = new char[nBufSize];
  int c, size = 0;

  while ((c = read(STDIN_FILENO, pcTemp + size, nBufSize)) > 0) {
    size += c;
  }

  Document *pDocument = new Document();

  BuildDoc(pDocument, pcTemp, size);

  struct timeval time1, time2;

  OptimizeFunc* optimizeFuncs[] = {

    CompressWhitespace,
    EliminateRedundancies,
    EmptyTags,
    EmptyReverseTags,
    CompressEM,

//    NestColors,
    RearrangeWhitespace,
    CombineText,
    NULL,
  };

  bool bFinishedOptimizing = false;
  OptimizeFunc **pFunc = optimizeFuncs;

  while (1) {
    bool bOptimized = false;
    for (pFunc = optimizeFuncs; *pFunc != NULL; pFunc++) {
      if ( (*pFunc)(pDocument) ) {
        bOptimized = true;
      }
    }
    if (!bOptimized) {
      break;
    }
  }

  c = pDocument->write(pcTemp);
  write(STDOUT_FILENO, pcTemp, c);
  
  return 0;
}
  
