
#include <stdio.h>
#include <unistd.h>

#include "Parser.h"

void PrintTag (void *pArg, const char *pcSource, int nSize, int nLineno, bool bStart) {
  printf ("tag: %s %d %d\n", pcSource, nLineno, bStart);
}

void PrintText (void *pArg, const char *pcSource, int nSize, int nLineno, bool bStart) {
  printf ("text: %s %d\n", pcSource, nLineno);
}

void PrintWhitespace (void *pArg, const char *pcSource, int nSize, int nLineno, bool bStart) {
  printf ("space: %d %d\n", nSize, nLineno);
}

void Tag_r (void *pArg, const char *pcSource, int nSize, int nLineno, bool bStart) {
  printf ("%d: tag r %d\n", nLineno, bStart);
}


int main (int argc, char **argv) {
  Parser *pParser = new Parser(PrintText, PrintWhitespace, PrintTag);

  pParser->registerCallback("r", Tag_r, NULL);

  char pcTemp[102400];
  int c = read(STDIN_FILENO, pcTemp, 102400);
  pParser->parse(pcTemp, c);

  return 0;
}
