#!/home/ronnie/bin/tclsh8.3

set inputDir inputs
set outputDir outputs

set topDir [pwd]
cd $inputDir
set files [glob *]
cd $topDir

foreach file $files {
  set inputFile $inputDir/$file
  set outputFile $outputDir/$file.comp
  puts "compressing $file..."
  set time1 [clock seconds]
  exec ./compress < $inputFile > $outputFile
  set timeElapsed [expr [clock seconds] - $time1]
  puts "input size [file size $inputFile], output size [file size $outputFile], time $timeElapsed"
  puts "comparing $file..."
  set result [exec ./compare $inputFile $outputFile]
  if {!$result} {
    puts "compare error for $file"
  }
}
